#include "zset.hh"

ZSet::ZSet()
{	
}

ZSet::~ZSet()
{
  for(z_map_t::iterator zm_iter = z_map.begin(); 
      zm_iter != z_map.end(); ++zm_iter) {
    assert(zm_iter->second);
    delete zm_iter->second;
  }
  z_map.clear();
}

NodeAttr *ZSet::get_node_attr(vertex_set_t & _z_set)
{
  z_map_t::iterator zm_iter = z_map.find(_z_set);
  NodeAttr *node_attr = NULL;
  if(zm_iter != z_map.end()) {
    node_attr = zm_iter->second;
  } 
  return node_attr;
}

NodeAttr *ZSet::insert(vertex_set_t & _z, indeg_t & _indeg, 
		       vertex_set_t & _alive)
{
  NodeAttr *node_attr = NULL;
  z_map_t::iterator zm_iter = z_map.find(_z);
  if(zm_iter == z_map.end()) {
    //Not in the ZSet
    node_attr = new NodeAttr(_z, _indeg, _alive);
    z_map[_z] = node_attr;
  } else {
    node_attr = zm_iter->second;
  }
  assert(node_attr);
  return node_attr;
}
